#ifndef __TYPES_H__
#define __TYPES_H__

#if defined (__x86_32__) 

typedef struct { unsigned long pte_low, pte_high; } pte_t;
#define __pte(x) ({unsigned long long _x = x; \
    ((pte_t) {(unsigned long)_x, (unsigned long)(_x >> 32)}); })

typedef unsigned long mfn_t;
typedef unsigned long pfn_t;

#elif defined (__x86_64__)

typedef struct { unsigned long pte; } pte_t;
#define __pte(x) ((pte_t){x})

typedef unsigned long mfn_t;
typedef unsigned long pfn_t;

#endif

#define PAGE_SIZE 12
#define NULL 0

#endif
