#include <stdint.h>
#include <xen/xen.h>
#include "console.h"
#include "hypercall.h"
#include "mem.h"
// Reserve space for the stack
char stack[8192];

// shared info declared in assembly, typed here
extern volatile shared_info_t shared_info;

// Main kernel entry point, called by trampoline
void start_kernel(start_info_t *start_info)
{
        // this hypervisor call is ignored unless Xen is recompiled
        // to do something with it
//	HYPERVISOR_console_io(CONSOLEIO_write, 19, "Nano-OS booting...\n");
	//Map the shared info page
	HYPERVISOR_update_va_mapping((unsigned long) &shared_info, __pte(start_info->shared_info | 3), UVMF_INVLPG);
//	init_events();

	console_init(start_info);
	console_write("Hello, world!\r\n");
	mymain();

	while (1);
}
