//#include<stdio.h>
#include "mem.h"
#include "console.h"


/*Copies first 2 characters from src to dest*/
void memcpy01() {
char src[]={"abc"};
char dest[]={"def"};
printf("testcase begins:memcpy01");
printf("%s",dest);
memcpy(dest,src,2);
printf("%s",dest);
printf("testcase ends");
}

/*Copies all the characters from src to dest.
Though n=4 only 3 are copied since null is encountered*/
void memcpy02() {
char src[]={"abc"};
char dest[]={"def"};
printf("testcase begins:memcpy02");
printf("%s",dest);
memcpy(dest,src,4);
printf("%s",dest);
printf("testcase ends");
}

/*Copies first 2 characters src to dest
though dest is pointing to null*/
void memcpy03() {
char src[]={"abc"};
char dest[]={"def"};
dest[0]='\0';
printf("testcase begins:memcpy03");
printf("%s",dest);
memcpy(dest,src,2);
printf("%s",dest);
printf("testcase ends");
}

/*Copies null from src to dest*/
void memcpy04() {
char src[]={"abc"};
char dest[]={"def"};
src[0]='\0';
printf("testcase begins:memcpy04");
printf("%s",dest);
memcpy(dest,src,2);
printf("%s",dest);
printf("testcase ends");
}

/*No error while pointers pointing to null are used*/
void memcpy05() {
char src[]={"abc"};
char dest[]={"def"};
src[0]='\0';
dest[0]='\0';
printf("testcase begins:memcpy05");
printf("%s",dest);
memcpy(dest,src,2);
printf("%s",dest);
printf("testcase ends");
}

/*Segmentation fault is thrown if a negative number is 
given for third argument*/
void memcpy06() {
char src[]={"abc"};
char dest[]={"def"};
printf("testcase begins:memcpy06");
memcpy(dest,src,-2);
printf("testcase ends");
}

/*Strings can directly be provided as arguments yielding 
no errors*/
void memcpy07() {
char dest[]={"def"};
printf("testcase begins:memcpy07");
printf("%s",dest);
memcpy(dest,"aaa",2);
printf("%s",dest);
printf("testcase ends");
}

/*Sets '-' in the first position pointed by dest*/ 
void memset01() {
char dest[]={"def"};
printf("testcase begins:memset01");
printf("%s",dest);
memset(dest,'-',1);
printf("%s",dest);
printf("testcase ends");
}

/*Sets 10 positions starting from dest with '-'*/
void memset02() {
char dest[]={"def"};
printf("testcase begins:memset02");
printf("%s",dest);
memset(dest,'-',10);
printf("%s",dest);
printf("testcase ends");
}

/*Sets 10 positions starting from dest with '-'
though dest is pointing to null*/
void memset03() {
char dest[]={"def"};
dest[0]='\0';
printf("testcase begins:memset03");
printf("%s",dest);
memset(dest,'-',10);
printf("%s",dest);
printf("testcase ends");
}

/*Returns a Segmentation Fault if n is negative*/
void memset04() {
char dest[]={"def"};
printf("testcase begins:memset04");
memset(dest,'-',-1);
printf("testcase ends");
}

/*Returns 3 on comparing the ascii value of 
'd' with 'a'*/
void strcmp01() {
char src[]={"abc"};
char dest[]={"def"};
char no[2];
int val=strcmp(dest,src);
no[0]=val+'0';
no[1]='\0';
printf("testcase begins:strcmp1");
console_write(no);
console_write("\r\n");
printf("testcase ends");
}

/*Strings can directly be provided as arguments*/
void strcmp02() {
char dest[]={"def"};
char no[2];
int val=strcmp(dest,"def");
no[0]=val+'0';
no[1]='\0';
printf("testcase begins:strcmp02");
console_write(no);
console_write("\r\n");
printf("testcase ends");
}

/*Value is returned even if src is pointing to null*/
void strcmp03() {
char src[]={"abc"};
char dest[]={"def"};
int len,val,qnt,rem,i=0;
char no[10],soln[10];
src[0]='\0';
val=strcmp(dest,src);
qnt=val;
while(qnt>0) {
rem=qnt%10;
qnt=qnt/10;
no[i]=rem+'0';
i++;
}
no[i]='\0';
i=0;
len=findlength(no);
while(i<len) {
soln[i]=no[len-i-1];
i++;
}
soln[i]='\0';
printf("testcase begins:strcmp03");
console_write(soln);
console_write("\r\n");
printf("testcase ends");
}

/*Value is returned even if dest is pointing to null*/
void strcmp04() {
char src[]={"abc"};
char dest[]={"def"};
int val,len,qnt,rem,i=0;
char no[10],soln[10];
dest[0]='\0';
printf("testcase begins:strcmp04");
val=strcmp(dest,src);
qnt=val*-1; //val is negative so multiplying by 1
while(qnt>0) {
rem=qnt%10;
qnt=qnt/10;
no[i]=rem+'0';
i++;
}
no[i]='\0';
i=0;
len=findlength(no);
while(i<len) {
soln[i]=no[len-i-1];
i++;
}
soln[i]='\0';
console_write("-");
console_write(soln);
console_write("\r\n");
printf("testcase ends");
}

/*Returns 3 on comparing the ascii value of 
'd' with 'a'. */
void strncmp01() {
char src[]={"abc"};
char dest[]={"def"};
char no[2];
printf("testcase begins:strncmp01");
int val=strncmp(dest,src,2);
no[0]=val+'0';
no[1]='\0';
console_write(no);
console_write("\r\n");
printf("testcase ends");
}

/*Strings can directly be provided as arguments*/
void strncmp02() {
char dest[]={"def"};
char no[2];
printf("testcase begins:strncmp02");
int val=strncmp(dest,"def",3);
no[0]=val+'0';
no[1]='\0';
console_write(no);
console_write("\r\n");
printf("testcase ends");
}

/*Value is returned even if src is pointing to null*/
void strncmp03() {
char src[]={"abc"};
char dest[]={"def"};
int len,val,rem,qnt,i=0;
char no[10],soln[10];
src[0]='\0';
printf("testcase begins:strncmp03");
val=strncmp(dest,src,2);
qnt=val;
while(qnt>0) {
rem=qnt%10;
qnt=qnt/10;
no[i]=rem+'0';
i++;
}
no[i]='\0';
i=0;
len=findlength(no);
while(i<len) {
soln[i]=no[len-i-1];
i++;
}
soln[i]='\0';
console_write(soln);
console_write("\r\n");
printf("testcase ends");
}

/*Value is returned even if dest is pointing to null*/
void strncmp04() {
char src[]={"abc"};
char dest[]={"def"};
int val,len,qnt,rem,i=0;
char no[10],soln[10];
dest[0]='\0';
printf("testcase begins:strncmp04");
val=strncmp(dest,src,2);
val=strncmp(dest,src,2);
qnt=val*-1;//val is negative so multiplying by 1
while(qnt>0) {
rem=qnt%10;
qnt=qnt/10;
no[i]=rem+'0';
i++;
}
no[i]='\0';
i=0;
len=findlength(no);
while(i<len) {
soln[i]=no[len-i-1];
i++;
}
soln[i]='\0';
console_write("-");
console_write(soln);
console_write("\r\n");
printf("testcase ends");
}

/*Value is returned even if both arguments are pointing to null*/
void strncmp05() {
char src[]={"abc"};
char dest[]={"def"};
int val;
char no[2];
src[0]='\0';
dest[0]='\0';
printf("testcase begins:strncmp05");
val=strncmp(dest,src,1);
no[0]=val+'0';
no[1]='\0';
console_write(no);
console_write("\r\n");
printf("testcase ends");
}


/*Concatenates src at the end of dest*/  
void strcat01() {
char src[]={"abc"};
char dest[]={"def"};
printf("testcase begins:strcat01");
printf("%s",dest);
strcat(dest,src);
printf("%s",dest);
printf("testcase ends");
}

/*Strings can directly be given as arguments*/
void strcat02() {
char dest[]={"def"};
printf("testcase begins:strcat02");
printf("%s",dest);
strcat(dest,"aaa");
printf("%s",dest);
printf("testcase ends");
}

/*Value returned even if src points to null*/
void strcat03() {
char src[]={"abc"};
char dest[]={"def"};
src[0]='\0';
printf("testcase begins:strcat03");
printf("%s",dest);
strcat(dest,src);
printf("%s",dest);
printf("testcase ends");
}

/*Value is returned even if dest points to null*/
void strcat04() {
char src[]={"abc"};
char dest[]={"def"};
dest[0]='\0';
printf("testcase begins:strcat04");
printf("%s",dest);
strcat(dest,src);
printf("%s",dest);
printf("testcase ends");
}

/*Value is returned even if both args point to null*/
void strcat05() {
char src[]={"abc"};
char dest[]={"def"};
dest[0]='\0';
src[0]='\0';
printf("testcase begins:strcat05");
printf("%s",dest);
strcat(dest,src);
printf("%s",dest);
printf("testcase ends");
}

/*Value is returned even if dest has no space
overflow is not checked*/
void strcat06() {
char dest[5]={"def"};
dest[0]='\0';
printf("testcase begins:strcat06");
printf("%s",dest);
strcat(dest,"aaaaaa");
printf("%s",dest);
printf("testcase ends");
}

/*Concatenates first two characters in src to the end of dest*/  
void strncat01() {
char src[]={"abc"};
char dest[]={"def"};
printf("testcase begins:strncat01");
printf("%s",dest);
strncat(dest,src,2);
printf("%s",dest);
printf("testcase ends");
}

/*Concatenates till the end of string pointed by src if n is specified 
to be more than the length of src*/
void strncat02() {
char src[]={"abc"};
char dest[]={"def"};
printf("testcase begins:strncat02");
printf("%s",dest);
strncat(dest,src,4);
printf("%s",dest);
printf("testcase ends");
}

/*Value returned even if src points to null*/
void strncat03() {
char src[]={"abc"};
char dest[]={"def"};
src[0]='\0';
printf("testcase begins:strncat03");
printf("%s",dest);
strncat(dest,src,3);
printf("%s",dest);
printf("testcase ends");
}

/*Value is returned even if dest points to null*/
void strncat04() {
char src[]={"abc"};
char dest[]={"def"};
dest[0]='\0';
printf("testcase begins:strncat04");
printf("%s",dest);
strncat(dest,src,1);
printf("%s",dest);
printf("testcase ends");
}

/*Value is returned even if both args point to null
No error is obtained*/
void strncat05() {
char src[]={"abc"};
char dest[]={"def"};
dest[0]='\0';
src[0]='\0';
printf("testcase begins:strncat05");
printf("%s",dest);
strncat(dest,src,2);
printf("%s",dest);
printf("testcase ends");
}

/*Strings can be provided directly without variable names*/
void strncat06() {
char src[]={"abc"};
char dest[]={"def"};
printf("testcase begins:strncat06");
printf("%s",dest);
strncat(dest,"aaaa",3);
printf("%s",dest);
printf("testcase ends");
}

/*Returns the result if a negative number is specified*/
void strncat07() {
char src[]={"abc"};
char dest[]={"def"};
printf("testcase begins:strncat07");
printf("%s",dest);
strncat(dest,src,-1);
printf("%s",dest);
printf("testcase ends");
}

/*Copies the string pointed by src to dest*/
void strcpy01() {
char src[]={"abc"};
char dest[]={"def"};
printf("testcase begins:strcpy01");
printf("%s",dest);
strcpy(dest,src);
printf("%s",dest);
printf("testcase ends");
}

/*Value is returned even if dest points to null*/
void strcpy02() {
char src[]={"abc"};
char dest[]={"def"};
dest[0]='\0';
printf("testcase begins:strcpy02");
printf("%s",dest);
strcpy(dest,src);
printf("%s",dest);
printf("testcase ends");
}

/*Value is returned even if src points to null*/
void strcpy03() {
char src[]={"abc"};
char dest[]={"def"};
src[0]='\0';
printf("testcase begins:strcpy03");
printf("%s",dest);
strcpy(dest,src);
printf("%s",dest);
printf("testcase ends");
}

/*Value is returned even if both args point to null*/
void strcpy04() {
char src[]={"abc"};
char dest[]={"def"};
src[0]='\0';
dest[0]='\0';
printf("testcase begins:strcpy04");
printf("%s",dest);
strcpy(dest,src);
printf("%s",dest);
printf("testcase ends");
}

/*Strings can directly be provided as arguments*/
void strcpy05() {
char dest[]={"def"};
printf("testcase begins:strcpy05");
printf("%s",dest);
strcpy(dest,"aaa");
printf("%s",dest);
printf("testcase ends");
}

/*Copies first 2 characters pointed by src to dest*/
void strncpy01() {
char src[]={"abc"};
char dest[]={"def"};
printf("testcase begins:strncpy01");
printf("%s",dest);
strncpy(dest,src,2);
printf("%s",dest);
printf("testcase ends");
}

/*Value is returned even if dest points to null*/
void strncpy02() {
char src[]={"abc"};
char dest[]={"def"};
dest[0]='\0';
printf("testcase begins:strncpy02");
printf("%s",dest);
strncpy(dest,src,2);
printf("%s",dest);
printf("testcase ends");
}

/*Value is returned even if src points to null*/
void strncpy03() {
char src[]={"abc"};
char dest[]={"def"};
src[0]='\0';
printf("testcase begins:strncpy03");
printf("%s",dest);
strncpy(dest,src,3);
printf("%s",dest);
printf("testcase ends");
}

/*Value is returned even if both args point to null*/
void strncpy04() {
char src[]={"abc"};
char dest[]={"def"};
src[0]='\0';
dest[0]='\0';
printf("testcase begins:strncpy04");
printf("%s",dest);
strncpy(dest,src,1);
printf("%s",dest);
printf("testcase ends");
}

/*Strings can directly be provided as arguments*/
void strncpy05() {
char dest[]={"def"};
printf("testcase begins:strncpy05");
printf("%s",dest);
strncpy(dest,"aaa",3);
printf("%s",dest);
printf("testcase ends");
}

/*Copies upto the end of src if n > than the length 
of string pointed by src*/
void strncpy06() {
char src[]={"abc"};
char dest[]={"dest"};
printf("testcase begins:strncpy06");
printf("%s",dest);
strncpy(dest,src,5);
printf("%s",dest);
printf("testcase ends");
}

/*Yields Segmentation fault if negative number is specified*/
void strncpy07() {
char src[]={"abc"};
char dest[]={"def"};
printf("testcase begins:strncpy07");
strncpy(dest,src,-1);
printf("testcase ends");
}

/*Compares the characters of string pointed by src with
that of dest and returns the result*/
void memcmp01() {
char src[]={"abc"};
char dest[]={"def"};
char no[2];
int val=memcmp(dest,src,1);
no[0]=val+'0';
no[1]='\0';
printf("testcase begins:memcmp01");
printf("%s",no);
printf("testcase ends");
}

/*Value is returned even if src points to null*/
void memcmp02() {
char src[]={"abc"};
char dest[]={"def"};
int val,len,qnt,rem,i=0;
char no[10],soln[10];
src[0]='\0';
val=memcmp(dest,src,1);
printf("testcase begins:memcmp02");
qnt=val;
while(qnt>0) {
rem=qnt%10;
qnt=qnt/10;
no[i]=rem+'0';
i++;
}
no[i]='\0';
i=0;
len=findlength(no);
while(i<len) {
soln[i]=no[len-i-1];
i++;
}
soln[i]='\0';
printf("%s",soln);
printf("testcase ends");
}

/*Value is returned even if dest points to null*/
void memcmp03() {
char src[]={"abc"};
char dest[]={"def"};
int val,len,qnt,rem,i=0;
char no[10],soln[10];
dest[0]='\0';
val=memcmp(dest,src,1);
printf("testcase begins:memcmp03");
qnt=val*-1; //val is negative so multiplying by -1
while(qnt>0) {
rem=qnt%10;
qnt=qnt/10;
no[i]=rem+'0';
i++;
}
no[i]='\0';
i=0;
len=findlength(no);
while(i<len) {
soln[i]=no[len-i-1];
i++;
}
soln[i]='\0';
console_write("-");
printf("%s",soln);
printf("testcase ends");
}

/*Value is returned even if both args point to null*/
void memcmp04() {
char src[]={"abc"};
char dest[]={"def"};
int val;
char no[2];
src[0]='\0';
dest[0]='\0';
val=memcmp(dest,src,1);
no[0]=val+'0';
no[1]='\0';
printf("testcase begins:memcmp04");
printf("%s",no);
printf("testcase ends");
}

/*Strings can directly be provided as arguments*/
void memcmp05() {
int val;
char no[2];
val=memcmp("aaa","abb",1);
no[0]=val+'0';
no[1]='\0';
printf("testcase begins:memcmp05");
printf("%s",no);
printf("testcase ends");
}

/*No error if negative number is specified for the third argument*/
void memcmp06() {
int val;
char no[2];
char src[]={"abc"};
char dest[]={"def"};
val=memcmp(dest,src,-1);
no[0]=val+'0';
no[1]='\0';
printf("testcase begins:memcmp06");
printf("%s",no);
printf("testcase ends");
}

int mymain() {
int a=-6765;
long b=90;
char c[]={"abcd"};
char *cat="cat";
char *dogGoesWoof="dog\0goes\0woof";
char str[100];
char *ptr=0;
memcpy01();
memcpy02();
memcpy03();
memcpy04();
memcpy05();
memcpy06();
memcpy07();
memset01();
memset02();
memset03();
memset04();
memcmp01();
memcmp02();
memcmp03();
memcmp04();
memcmp05();
memcmp06();
strcat01();
strcat02();
strcat03();
strcat04();
strcat05();
strcat06();
strncat01();
strncat02();
strncat03();
strncat04();
strncat05();
strncat06();
strncat07();
strcmp01();
strcmp02();
strcmp03();
strcmp04();
strncmp01();
strncmp02();
strncmp03();
strncmp04();
strncmp05();
strcpy01();
strcpy02();
strcpy03();
strcpy04();
strcpy05();
strncpy01();
strncpy02();
strncpy03();
strncpy04();
strncpy05();
strncpy06();
strncpy07();
printf("%d",a);printf("%d %d",a,b);printf("%x",a);printf("%u",a);printf("%dl",b);
printf("%xl",b);printf("%ul",b);printf("%s",c);
//Output for questions asked in the assignemnt
memset(str,0,100);
/*sets 100 bytes str to null. on output of str nothing was returned. 
This confirms the presence of nulls*/
strcat(str,cat);
printf("%s",str);
/*string stored in str was "cat" which is the same as the string in cat*/
strcpy(str,dogGoesWoof);
printf("%s",str);
/*string stored in str was "dog"
copies till '\0 is encountered in src string i.e dogGoesWoof*/
strcpy(str+1,str); //output:ddog
printf("%s",str);
memcpy(str,cat,22); //output "cat" is stored in str
printf("%s",str);
*ptr='a'; //Segmentation fault 
}
